Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis4.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis4.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis4.F90	(revision 2620)
@@ -5,17 +5,16 @@
    !!=====================================================================
    !! History :   
-   !!   9.0  !  04-06  (R. Redler, NEC Laboratories Europe, St Augustin, Germany) Original code
-   !!   " "  !  04-11  (R. Redler, NEC Laboratories Europe; N. Keenlyside, W. Park, IFM-GEOMAR, Kiel, Germany) revision
-   !!   " "  !  04-11  (V. Gayler, MPI M&D) Grid writing
-   !!   " "  !  05-08  (R. Redler, W. Park) frld initialization, paral(2) revision
-   !!   " "  !  05-09  (R. Redler) extended to allow for communication over root only
-   !!   " "  !  06-01  (W. Park) modification of physical part
-   !!   " "  !  06-02  (R. Redler, W. Park) buffer array fix for root exchange
-   !!   " "  !  2010   (E. Maisonnave and S. Masson) complete rewrite
+   !!   9.0  !  2004-06  (R. Redler, NEC Laboratories Europe, St Augustin, Germany) Original code
+   !!    -   !  2004-11  (R. Redler, NEC Laboratories Europe; N. Keenlyside, W. Park, IFM-GEOMAR, Kiel, Germany) revision
+   !!    -   !  2004-11  (V. Gayler, MPI M&D) Grid writing
+   !!    -   !  2005-08  (R. Redler, W. Park) frld initialization, paral(2) revision
+   !!    -   !  2005-09  (R. Redler) extended to allow for communication over root only
+   !!    -   !  2006-01  (W. Park) modification of physical part
+   !!    -   !  2006-02  (R. Redler, W. Park) buffer array fix for root exchange
+   !!    -   !  2010-10  (E. Maisonnave and S. Masson) complete rewrite
    !!----------------------------------------------------------------------
 #if defined key_oasis4
    !!----------------------------------------------------------------------
    !!   'key_oasis4'                    coupled Ocean/Atmosphere via OASIS4
-   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   cpl_prism_init     : initialization of coupled mode communication
@@ -35,5 +34,12 @@
    IMPLICIT NONE
    PRIVATE
-!
+
+   PUBLIC cpl_prism_init
+   PUBLIC cpl_prism_define
+   PUBLIC cpl_prism_snd
+   PUBLIC cpl_prism_rcv
+   PUBLIC cpl_prism_update_time
+   PUBLIC cpl_prism_finalize
+   
 !   LOGICAL, PUBLIC, PARAMETER :: lk_cpl = .TRUE.    ! coupled flag
    INTEGER                    :: ncomp_id           ! id returned by prism_init_comp
@@ -59,23 +65,12 @@
    TYPE(PRISM_Time_struct), PUBLIC    :: date_bound(2)   ! date info for send operation
 
-
-   !! Routine accessibility
-   PUBLIC cpl_prism_init
-   PUBLIC cpl_prism_define
-   PUBLIC cpl_prism_snd
-   PUBLIC cpl_prism_rcv
-   PUBLIC cpl_prism_update_time
-   PUBLIC cpl_prism_finalize
-
-   !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
-   !! $Header$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
-   SUBROUTINE cpl_prism_init (kl_comm) 
-
+   SUBROUTINE cpl_prism_init( kl_comm ) 
       !!-------------------------------------------------------------------
       !!             ***  ROUTINE cpl_prism_init  ***
@@ -86,6 +81,6 @@
       !! ** Method  :   OASIS4 MPI communication 
       !!--------------------------------------------------------------------
-      INTEGER, INTENT(   OUT )   :: kl_comm       ! local communicator of the model
-      !
+      INTEGER, INTENT(out) ::   kl_comm   ! local communicator of the model
+      !!--------------------------------------------------------------------
       
       CALL prism_init( 'nemo', nerror )
@@ -102,11 +97,9 @@
       CALL prism_get_localcomm( ncomp_id, kl_comm, nerror )
       IF( nerror /= PRISM_Success )   CALL prism_abort( ncomp_id, 'cpl_prism_init', 'Failure in prism_get_localcomm' )
-
-
+      !
    END SUBROUTINE cpl_prism_init
 
 
-   SUBROUTINE cpl_prism_define (krcv, ksnd)
-
+   SUBROUTINE cpl_prism_define( krcv, ksnd )
       !!-------------------------------------------------------------------
       !!             ***  ROUTINE cpl_prism_define  ***
@@ -120,23 +113,20 @@
       USE wrk_nemo, ONLY: zclo => wrk_3d_1, zcla => wrk_3d_2
       USE wrk_nemo, ONLY: zlon => wrk_2d_1, zlat => wrk_2d_2
-      !!
-      INTEGER, INTENT( IN    )   :: krcv, ksnd     ! Number of received and sent coupling fields
+      !
+      INTEGER, INTENT(in) :: krcv, ksnd     ! Number of received and sent coupling fields
       !
       INTEGER, DIMENSION(4)      :: igrid     ! ids returned by prism_def_grid
       INTEGER, DIMENSION(4)      :: iptid     ! ids returned by prism_set_points
-
-      INTEGER, DIMENSION(4)      :: imskid  ! ids returned by prism_set_mask
-      INTEGER, DIMENSION(4)      :: iishift     ! 
-      INTEGER, DIMENSION(4)      :: ijshift    ! 
+      INTEGER, DIMENSION(4)      :: imskid    ! ids returned by prism_set_mask
+      INTEGER, DIMENSION(4)      :: iishift   ! 
+      INTEGER, DIMENSION(4)      :: ijshift   ! 
       INTEGER, DIMENSION(4)      :: iioff     ! 
-      INTEGER, DIMENSION(4)      :: ijoff    ! 
-      INTEGER, DIMENSION(4)      :: itmp    ! 
-      INTEGER, DIMENSION(1,3)    :: iextent    ! 
-      INTEGER, DIMENSION(1,3)    :: ioffset    ! 
-
-
-      INTEGER                    :: ishape(2,3)     ! shape of arrays passed to PSMILe
+      INTEGER, DIMENSION(4)      :: ijoff     ! 
+      INTEGER, DIMENSION(4)      :: itmp      ! 
+      INTEGER, DIMENSION(1,3)    :: iextent   ! 
+      INTEGER, DIMENSION(1,3)    :: ioffset   ! 
+
+      INTEGER                    :: ishape(2,3)    ! shape of arrays passed to PSMILe
       INTEGER                    :: data_type      ! data type of transients
-
 
       LOGICAL                    :: new_points
@@ -144,7 +134,7 @@
       LOGICAL, ALLOCATABLE, SAVE :: llmask(:,:,:) ! jpi,jpj,1
 
-      INTEGER                    :: ji, jj, jg, jc     ! local loop indicees
-      INTEGER                    :: ii,ij     ! index
-      INTEGER, DIMENSION(1)      :: ind     ! index
+      INTEGER                    :: ji, jj, jg, jc   ! local loop indicees
+      INTEGER                    :: ii, ij           ! index
+      INTEGER, DIMENSION(1)      :: ind              ! index
 
       CHARACTER(len=32)          :: clpt_name     ! name of the grid points
@@ -154,11 +144,9 @@
       TYPE(PRISM_Time_struct)    :: tmpdate
       INTEGER                    :: idate_incr      ! date increment
-      !!
-      !!--------------------------------------------------------------------
-
-      IF( (.not. wrk_use(3, 1,2)) .OR. (.not. wrk_use(2, 1,2)) )THEN
-         CALL ctl_stop('cpl_prism_define: ERROR: requested workspace arrays are unavailable.')
-         RETURN
-      END IF
+      !!--------------------------------------------------------------------
+
+      IF( .NOT. wrk_use(3, 1,2) .OR. .NOT. wrk_use(2, 1,2) )THEN
+         CALL ctl_stop('cpl_prism_define: ERROR: requested workspace arrays are unavailable.')   ;   RETURN
+      ENDIF
 
       IF(lwp) WRITE(numout,*)
@@ -333,13 +321,11 @@
       IF ( nerror /= PRISM_Success )   CALL prism_abort ( ncomp_id, 'cpl_prism_define', 'Failure in prism_enddef')
       
-      IF( (.not. wrk_release(3, 1,2)) .OR. (.not. wrk_release(2, 1,2)) )THEN
-         CALL ctl_stop('cpl_prism_define: ERROR: failed to release workspace arrays.')
-      END IF
-
+      IF( .not. wrk_release(3, 1,2) .OR.   &
+          .not. wrk_release(2, 1,2)   )   CALL ctl_stop('cpl_prism_define: failed to release workspace arrays')
+      !
    END SUBROUTINE cpl_prism_define
    
    
    SUBROUTINE cpl_prism_snd( kid, kstep, pdata, kinfo )
-
       !!---------------------------------------------------------------------
       !!              ***  ROUTINE cpl_prism_snd  ***
@@ -348,12 +334,8 @@
       !!      like sst or ice cover to the coupler or remote application.
       !!----------------------------------------------------------------------
-      !! * Arguments
-      !!
-      INTEGER,                      INTENT( IN    )   :: kid       ! variable intex in the array
-      INTEGER,                      INTENT(   OUT )   :: kinfo     ! OASIS4 info argument
-      INTEGER,                      INTENT( IN    )   :: kstep     ! ocean time-step in seconds
-      REAL(wp),     DIMENSION(:,:), INTENT( IN    )   :: pdata
-      !!
-      !!
+      INTEGER                 , INTENT(in   ) ::   kid     ! variable intex in the array
+      INTEGER                 , INTENT(  out) ::   kinfo   ! OASIS4 info argument
+      INTEGER                 , INTENT(in   ) ::   kstep   ! ocean time-step in seconds
+      REAL(wp), DIMENSION(:,:), INTENT(in   ) ::   pdata
       !!--------------------------------------------------------------------
       !
@@ -365,5 +347,5 @@
          &                                               'Failure in prism_put for '//TRIM(ssnd(kid)%clname) )
 
-      IF ( ln_ctl ) THEN        
+      IF( ln_ctl ) THEN        
          IF ( kinfo >= PRISM_Cpl     .OR. kinfo == PRISM_Rst .OR.   &
             & kinfo == PRISM_RstTimeop ) THEN
@@ -377,11 +359,11 @@
             WRITE(numout,*) '     -     Sum value is ', SUM(pdata)
             WRITE(numout,*) '****************'
-        ENDIF
-     ENDIF
-    END SUBROUTINE cpl_prism_snd
+         ENDIF
+      ENDIF
+      !
+   END SUBROUTINE cpl_prism_snd
 
 
    SUBROUTINE cpl_prism_rcv( kid, kstep, pdata, kinfo )
-
       !!---------------------------------------------------------------------
       !!              ***  ROUTINE cpl_prism_rcv  ***
@@ -390,9 +372,9 @@
       !!      like stresses and fluxes from the coupler or remote application.
       !!----------------------------------------------------------------------
-      INTEGER,                      INTENT( IN    )   :: kid       ! variable intex in the array
-      INTEGER,                      INTENT( IN    )   :: kstep     ! ocean time-step in seconds
-      REAL(wp),     DIMENSION(:,:), INTENT( INOUT )   :: pdata     ! IN to keep the value if nothing is done
-      INTEGER,                      INTENT(   OUT )   :: kinfo     ! OASIS4 info argument
-      !!
+      INTEGER                 , INTENT(in   ) ::   kid     ! variable intex in the array
+      INTEGER                 , INTENT(in   ) ::   kstep   ! ocean time-step in seconds
+      REAL(wp), DIMENSION(:,:), INTENT(inout) ::   pdata   ! IN to keep the value if nothing is done
+      INTEGER                 , INTENT(  out) ::   kinfo   ! OASIS4 info argument
+      !
       LOGICAL                :: llaction
       !!--------------------------------------------------------------------
@@ -435,11 +417,9 @@
          kinfo = OASIS_idle     
       ENDIF
-
-
+      !
    END SUBROUTINE cpl_prism_rcv
 
 
    SUBROUTINE cpl_prism_finalize
-
       !!---------------------------------------------------------------------
       !!              ***  ROUTINE cpl_prism_finalize  ***
@@ -449,33 +429,30 @@
       !!      MPI communication.
       !!----------------------------------------------------------------------
-
+      !
       DEALLOCATE(exfld)
       CALL prism_terminate ( nerror )         
-
+      !
    END SUBROUTINE cpl_prism_finalize
 
+
    SUBROUTINE cpl_prism_update_time(kt)
-
       !!---------------------------------------------------------------------
       !!              ***  ROUTINE cpl_prism_update_time  ***
       !!
       !! ** Purpose : - Increment date with model timestep
-      !!      called explicitly at the end of each timestep
+      !!                called explicitly at the end of each timestep
       !!----------------------------------------------------------------------
-
-      INTEGER, INTENT(in) ::   kt       ! ocean model time step index
-
-      TYPE(PRISM_Time_struct)    :: tmpdate
-      INTEGER                    :: idate_incr     ! date increment
-
-
-      IF( kt == nit000 ) THEN
-      !
-      ! Define the actual date 
-      !
-      ! date is determined by adding days since beginning of the run to the corresponding initial date.
-      ! Note that OPA internal info about the start date of the experiment is bypassed.
-      ! Instead we rely sololy on the info provided by the SCC.xml file.
-      !
+      INTEGER, INTENT(in) ::   kt   ! ocean model time step index
+
+      TYPE(PRISM_Time_struct) ::   tmpdate
+      INTEGER                 ::   idate_incr   ! date increment
+      !!----------------------------------------------------------------------
+
+      IF( kt == nit000 ) THEN      ! Define the actual date 
+         !
+         ! date is determined by adding days since beginning of the run to the corresponding initial date.
+         ! Note that OPA internal info about the start date of the experiment is bypassed.
+         ! Instead we rely sololy on the info provided by the SCC.xml file.
+         !
          date = PRISM_Jobstart_date
          !
@@ -486,9 +463,7 @@
          tmpdate = date   ;   CALL PRISM_calc_newdate ( tmpdate, -idate_incr, nerror )   ;   date_bound(1) = tmpdate
          tmpdate = date   ;   CALL PRISM_calc_newdate ( tmpdate,  idate_incr, nerror )   ;   date_bound(2) = tmpdate
-
-      ELSE
-      !
-      ! Date update
-      !
+         !
+      ELSE      ! Date update
+         !
          idate_incr  = rdttra(1)
          CALL PRISM_calc_newdate( date, idate_incr, nerror )
@@ -497,10 +472,11 @@
          CALL PRISM_calc_newdate( tmpdate, idate_incr, nerror )
          date_bound(2) = tmpdate
-
+         !
       END IF
-
+      !
    END SUBROUTINE cpl_prism_update_time
 
 #endif
 
+   !!=====================================================================
 END MODULE cpl_oasis4
